source: scripts/patch/vim-patch.sh @ 4648865

clfs-1.2clfs-2.1clfs-3.0.0-systemdclfs-3.0.0-sysvinitsystemdsysvinit
Last change on this file since 4648865 was 4648865, checked in by Jim Gifford <clfs@…>, 11 years ago

Really fix the patch scripts.

  • Property mode set to 100755
File size: 3.8 KB
Line 
1#!/bin/bash
2# Create a VIM Patch
3
4# Get Version #
5#
6VERSION=$1
7
8# Check Input
9#
10if [ "${VERSION}" = "" ]; then
11  echo "$0 - Vim_Version"
12  echo "This will Create a Patch for Vim Vim_Version"
13  exit 255
14fi
15
16# Get the # of Patches
17#
18cd ~/tmp
19wget ftp://ftp.vim.org/pub/vim/patches/${VERSION}/ --no-remove-listing
20FILES=$(cat index.html | grep "${VERSION}" | cut -f6 -d. | cut -f1 -d'"' | sed '/^$/d' | tail -n 1)
21rm -f .listing
22rm -f index.html
23SERIES=$(echo ${VERSION} | sed -e 's/\.//g')
24SKIPPATCH=""
25SKIPPED=""
26
27# Download VIM Source
28#
29if ! [ -e vim-${VERSION}.tar.bz2 ]; then
30  wget ftp://ftp.vim.org/pub/vim/unix/vim-${VERSION}.tar.bz2
31fi
32
33# Set Patch Number
34#
35cd ~/tmp
36wget http://svn.cross-lfs.org/svn/repos/patches/vim/ --no-remove-listing
37for num in $(seq 1 99); do
38  PATCH_NUM=$(cat index.html | grep "${VERSION}" | grep branch_update-${num}.patch | cut -f2 -d'"' | cut -f1 -d'"'| cut -f4 -d- | cut -f1 -d. | tail -n 1)
39  if [ "${PATCH_NUM}" = "0" -a "${num}" = "1" ]; then
40    PATCH_NUM=$(expr ${PATCH_NUM} + 1)
41    break
42  fi
43  if [ "${PATCH_NUM}" != "${num}" ]; then
44    PATCH_NUM=$(expr ${num})
45    break
46  fi
47done
48rm -f index.html
49
50# Cleanup Directory
51#
52rm -rf vim${SERIES} vim${SERIES}.orig
53tar xvf vim-${VERSION}.tar.bz2
54cp -ar vim${SERIES} vim${SERIES}.orig
55
56# Download and Apply Patches
57#
58install -d ~/tmp/vim-${VERSION}-patches
59cd ~/tmp/vim${SERIES}
60CURRENTDIR=$(pwd -P)
61PATCHURL=ftp://ftp.vim.org/pub/vim/patches/${VERSION}
62COUNT=1
63while [ ${COUNT} -le ${FILES} ]; do
64  cd ~/tmp/vim${SERIES}
65  DLCOUNT="${COUNT}"
66  SKIPME=no
67  if [ "${COUNT}" -lt "100" ]; then
68    DLCOUNT="0${COUNT}"
69  fi
70  if [ "${COUNT}" -lt "10" ]; then
71    DLCOUNT="00${COUNT}"
72  fi
73  for skip in ${SKIPPATCH} ; do
74    if [ "${DLCOUNT}" = "${skip}" ]; then
75      echo "Patch ${VERSION}.${DLCOUNT} skipped"
76      SKIPPED="${SKIPPED} ${DLCOUNT}"
77      SKIPME=yes
78    fi
79  done
80  if [ "${SKIPME}" != "yes" ]; then
81    if ! [ -e ${VERSION}.${DLCOUNT} ]; then
82      cd ~/tmp/vim-${VERSION}-patches
83      wget --quiet $PATCHURL/${VERSION}.${DLCOUNT}
84    fi
85    cd $CURRENTDIR
86    patch --dry-run -s -f -Np0 -i ~/tmp/vim-${VERSION}-patches/${VERSION}.${DLCOUNT}
87    if [ "$?" = "0" ]; then
88      echo "Patch ${VERSION}.${DLCOUNT} applied"
89      patch -s -Np0 -i ~/tmp/vim-${VERSION}-patches/${VERSION}.${DLCOUNT}
90    else
91      echo "Patch ${VERSION}.${DLCOUNT} not applied"
92      SKIPPED="${SKIPPED} ${DLCOUNT}"
93    fi
94   fi
95   COUNT=$(expr ${COUNT} + 1)
96done
97
98# Cleanup Directory
99#
100for dir in $(find * -type d); do
101  cd ~/tmp/vim${SERIES}
102  for file in $(find . -name '*~'); do
103    rm -f ${file}
104  done
105  for file in $(find . -name '*.orig'); do
106    rm -f ${file}
107  done
108done
109cd ~/tmp/vim${SERIES}
110rm -f *~ *.orig
111
112# Create Patch
113#
114cd ~/tmp
115echo "Submitted By: Jim Gifford (jim at cross-lfs dot org)" > ~/patches/vim-${VERSION}-branch_update-${PATCH_NUM}.patch
116echo "Date: `date +%m-%d-%Y`" >> ~/patches/vim-${VERSION}-branch_update-${PATCH_NUM}.patch
117echo "Initial Package Version: ${VERSION}" >> ~/patches/vim-${VERSION}-branch_update-${PATCH_NUM}.patch
118echo "Origin: Upstream" >> ~/patches/vim-${VERSION}-branch_update-${PATCH_NUM}.patch
119echo "Upstream Status: Applied" >> ~/patches/vim-${VERSION}-branch_update-${PATCH_NUM}.patch
120echo "Description: Contains all upstream patches up to ${VERSION}.${FILES}" >> ~/patches/vim-${VERSION}-branch_update-${PATCH_NUM}.patch
121if [ -n "${SKIPPED}" ]; then
122  echo "             The following patches were skipped" >> ~/patches/vim-${VERSION}-branch_update-${PATCH_NUM}.patch
123  echo "            ${SKIPPED}" >> ~/patches/vim-${VERSION}-branch_update-${PATCH_NUM}.patch
124fi
125echo "" >> ~/patches/vim-${VERSION}-branch_update-${PATCH_NUM}.patch
126diff -Naur vim${SERIES}.orig vim${SERIES} >> ~/patches/vim-${VERSION}-branch_update-${PATCH_NUM}.patch
127echo "Created ~/patches/vim-${VERSION}-branch_update-${PATCH_NUM}.patch."
128
129# Cleanup Directory
130#
131rm -rf vim${SERIES} vim${SERIES}.orig
Note: See TracBrowser for help on using the repository browser.